// Function to update thumbnails so the correct one is shown as selected
function bitVolImgGal_selectThumbnail(gallery,ATagContainingThumbnail)
{
    // Remove 'selected' from other thumbnails and add it to current one
    jQuery(gallery).find('img.selected').removeClass('selected').fadeTo('fast','0.3');
    jQuery(ATagContainingThumbnail).children('img').addClass('selected').fadeTo('fast',1);

    // Remove 'selected' from other list items and add it to current one
    jQuery(gallery).find('li.selected').removeClass('selected');
    jQuery(ATagContainingThumbnail).closest("li").addClass('selected');
}

// Function to update main image so it shows a large version of the selected thumbnail image
function bitVolImgGal_setmainImg(mainImg,thumbLink,plugin_directory)
{
    // Display a "loading" image so there is something in view until the proper one has downloaded
    jQuery(mainImg).attr('width',32).attr('height',32).attr('src', plugin_directory+'/images/icons/loading.gif');

    // Extract main image dimensions that are hidden in the alt of the thumbs (e.g. thumb0_500x375)
    var newWidth = jQuery(thumbLink).find('img').attr('alt').replace(/^thumb\d+\_/,"");
    var newHeight = newWidth;
    newWidth = newWidth.replace(/x\d+$/,"");
    newHeight = newHeight.replace(/^\d+x/,"");

    // et the new image src, title, width and height
    jQuery(mainImg).attr('src', jQuery(thumbLink).attr('href'));
    jQuery(mainImg).attr('title', jQuery(thumbLink).attr('title'));
    if (newWidth > 0 && newHeight > 0) {
        jQuery(mainImg).attr('width', newWidth).attr('height', newHeight);
    }
}

jQuery(document).ready(function($) {

    // Directory path of this plugin
    var plugin_directory = "/wp-content/plugins/bitvolution-image-galleria";

    // Thumbnail hover fade effects
    $('.gallery li img').hover(
        function() {jQuery(this).fadeTo('fast',1);},
        function() {jQuery(this).not('.selected').fadeTo('fast','0.3');}
    );

    // Allow user to click thumbnails to select main image
    $('.gallery li a').click(function() {

        var currentThumbLink = this; // save current link cos we'll change it
        var currentGallery = jQuery(currentThumbLink).parents('div.gallery');

        // Update main image
        bitVolImgGal_setmainImg(jQuery(currentGallery).find('img.mainImage')[0],currentThumbLink,plugin_directory);

        // Update thumbnail image grid
        bitVolImgGal_selectThumbnail(currentGallery,currentThumbLink);

        return false;
    });

    // Allow user to click the image to go to the next one
    $('.gallery img.mainImage').click(function() {

        var currentGallery = jQuery(this).parents('div.gallery');
        var selectedLI = jQuery(currentGallery).find("li.selected")[0];
        var nextLI = jQuery(selectedLI).is(':last-child') ? jQuery(selectedLI).siblings(':first-child') : jQuery(selectedLI).next();
        var nextA  = jQuery(nextLI).find('a');

        // Update main image
        bitVolImgGal_setmainImg(this,nextA,plugin_directory);

        // Update thumbnail image grid
        bitVolImgGal_selectThumbnail(currentGallery,nextA);
    });

});
